#if defined(__linux__)
#if defined(__bfin__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       364

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getdents    141
#define SYS_getcwd      183

	.section .text

	.globl	____exit
	.type	____exit, @function
____exit:
	P0	= SYS_exit
	EXCPT	0
	RTS

	.globl	___fork
	.type	___fork, @function
___fork:
	P0	= SYS_fork
	EXCPT	0
	RTS

	.globl	___wait4
	.type	___wait4, @function
___wait4:
	P0	= SYS_wait4
	EXCPT	0
	RTS

	.globl	___kill
	.type	___kill, @function
___kill:
	P0	= SYS_kill
	EXCPT	0
	RTS

	.globl	___execve
	.type	___execve, @function
___execve:
	P0	= SYS_execve
	EXCPT	0
	RTS

	.globl	___read
	.type	___read, @function
___read:
	P0	= SYS_read
	EXCPT	0
	RTS

	.globl	___write
	.type	___write, @function
___write:
	P0	= SYS_write
	EXCPT	0
	RTS

	.globl	___open
	.type	___open, @function
___open:
	P0	= SYS_open
	EXCPT	0
	RTS

	.globl	___close
	.type	___close, @function
___close:
	P0	= SYS_close
	EXCPT	0
	RTS

	.globl	___dup
	.type	___dup, @function
___dup:
	P0	= SYS_dup
	EXCPT	0
	RTS

	.globl	___pipe
	.type	___pipe, @function
___pipe:
	P0	= SYS_pipe
	EXCPT	0
	RTS

	.globl	___dup2
	.type	___dup2, @function
___dup2:
	P0	= SYS_dup2
	EXCPT	0
	RTS

	.globl	___pipe2
	.type	___pipe2, @function
___pipe2:
	P0	= SYS_pipe2
	EXCPT	0
	RTS

	.globl	___sigaction
	.type	___sigaction, @function
___sigaction:
	P0	= SYS_sigaction
	EXCPT	0
	RTS

	.globl	___sigprocmask
	.type	___sigprocmask, @function
___sigprocmask:
	P0	= SYS_sigprocmask
	EXCPT	0
	RTS

	.globl	___getpid
	.type	___getpid, @function
___getpid:
	P0	= SYS_getpid
	EXCPT	0
	RTS

	.globl	___getppid
	.type	___getppid, @function
___getppid:
	P0	= SYS_getppid
	EXCPT	0
	RTS

	.globl	___getsid
	.type	___getsid, @function
___getsid:
	P0	= SYS_getsid
	EXCPT	0
	RTS

	.globl	___setsid
	.type	___setsid, @function
___setsid:
	P0	= SYS_setsid
	EXCPT	0
	RTS

	.globl	___getpgid
	.type	___getpgid, @function
___getpgid:
	P0	= SYS_getpgid
	EXCPT	0
	RTS

	.globl	___setpgid
	.type	___setpgid, @function
___setpgid:
	P0	= SYS_setpgid
	EXCPT	0
	RTS

	.globl	___getpgrp
	.type	___getpgrp, @function
___getpgrp:
	P0	= SYS_getpgrp
	EXCPT	0
	RTS

	.globl	___chdir
	.type	___chdir, @function
___chdir:
	P0	= SYS_chdir
	EXCPT	0
	RTS

	.globl	___ioctl
	.type	___ioctl, @function
___ioctl:
	P0	= SYS_ioctl
	EXCPT	0
	RTS

	.globl	___brk
	.type	___brk, @function
___brk:
	P0	= SYS_brk
	EXCPT	0
	RTS

	.globl	___getdents
	.type	___getdents, @function
___getdents:
	P0	= SYS_getdents
	EXCPT	0
	RTS

	.globl	_____getcwd
	.type	_____getcwd, @function
_____getcwd:
	P0	= SYS_getcwd
	EXCPT	0
	RTS
#endif
#endif
